#!/usr/bin/python

####################
######IMPORTANT#####
#  xpk filename prefix must be residue number of mutation#
####################

#reads in all files with xpk extension, difference from reference
#converts ppm to Hz as if at 750MHz 
import glob

###USER SETTING####
#read in ref WT xpk file
fh = open("wt_p38gnew2.xpk","r")
###################

#read in all xpk files
files = glob.glob("*.xpk")
print files
xarr = []
for line in fh:
  i = line.split()
  vsort = 0
  #2D xpk files: skip headers and read only lines with assignment and shift data
  if len(i) > 19:
     if float(i[19]) == 0 and i[1] != "{?}" and i[8] != "{?}":
       try:
         reshead = i[1].split(".",1)
         #residue numbers
         xarr.append([(int(reshead[0].strip('{}'))),float(i[2]),float(i[9]),reshead[1].strip('{}')])
       except:
	 pass
     else:
       pass
diffarr = []
for file in files:
   k = 0
   temp = open(file.strip(),"r")
   outt = open(file+".diff","w")
   for line in temp:
      j = line.split()
      if len(j) > 19:
         if float(j[19]) == 0 and j[1] != "{?}" and j[8] != "{?}":
          try:
            res = j[1].split(".",1)
            resid = int(res[0].strip('{}'))
            resen = res[1].strip('{}')
            if resid == xarr[k][0] and resen == xarr[k][3]:
          ##   ## remove unwanted residues here:  ##  ##
             #if (resid == 283 and resen == "hd1") or (resid == 78 and resen == "hd12") or (resid == 107):
             if (resid == 9999):
               print "skipped"
               k+=1 
             else:
               ppmdff = ((((xarr[k][1]-float(j[2]))*750)**2)+(((xarr[k][2]-float(j[9]))*188)**2))**0.5
               outt.write("%i %s %f\n"%(resid, resen, ppmdff))
               k += 1
            else:
             #peak list labels between WT and mutants need to match
             #if this prints there is a mismatch in xpk files that needs to be fixed
             print "residue mismatch!"
          except:
           pass
         else:
          pass
      else:
        pass
   temp.close()
   outt.close()

